Subject: Re: bug#20063: 24.4: read-from-minibuffer improperly setting hist parameter

From: Stefan Monnier <[email-masked]>
Date: Mon, 09 Mar 2015 14:14:34 -0400

> 1] From a programmer's perspective, forcing a HIST when the programmer
> asks for COLLECTION = !nil and HIST = nil, creates a conflict when
> parameter REQUIRE-MATCH is set to `t', because the mini-buffer will
> offer entries, from HIST, that are not in COLLECTION, and those entries
> will then just be rejected due to REQUIRE-MATCH.

That is indeed a problem, but it is more general than the case of
HIST=nil, since even if HIST is non-nil the history may contain entries
which are not valid according to COLLECTION.

So what we need to do is to filter out those entries dynamically.

> 2] From a programmer's perspective, there are four legitimate
> combinations of COLLECTION and HIST, and the current state denies a
> programmer the freedom to offer a specific COLLECTION without some
> general HIST.

Actually, IIRC a value of t for HIST does provide the option of "no history".

        Stefan